# -*- coding:sjis -*-
#wavt@Cǂݍނ߂̃W[

class Wave:
    
    def __getitem__(self,key):
        info=self.info
        data=self.data
        bit=info["bit"]
        block_size=info["channel"]*(bit/8)
        start=key.start or 0
        stop=key.stop or len(data)/block_size
        if not info["format_id"]==1:
            raise"Sorry, I don't know this format_id."
        list_set=[[]for _ in xrange(info["channel"])]
        i=start*block_size
        while i<stop*block_size:
            for li in list_set:
                n=stoi(data[i:i+bit/8])
                i+=bit/8
                if n>32767:
                    n=n-65536
                li.append(n)
        return list_set

                

def read(s,_check=True):
    wave=Wave()
    info={}
    info["tag"]=[]
    if _check and not s[0:4]=="RIFF":
        raise""
    if _check and not stoi(s[4:8])==len(s)-8:
        raise"File_size"
    if _check and not s[8:12]=="WAVE":
        raise""
    i=12
    for _ in xrange(100):
        tag=s[i:i+4]
        n=stoi(s[i+4:i+8])
        data=s[i+8:i+8+n]
        i+=8+n
        info["tag"].append(tag)
        if tag=="fmt ":
            fmt(info,data)
        if tag=="data":
            wave.data=data
        if i>=len(s):
            break
    else:
        raise"too many tag"
    wave.info=info
    return wave
        

def stoi(s):
    n=0;dn=1
    for i in s:
        n+=dn*ord(i)
        dn*=256
    return n

def fmt(wave,data):
    wave["format_id"]=stoi(data[0:2])
    wave["channel"]=stoi(data[2:4])
    wave["rate"]=stoi(data[4:8])
    data_speed=stoi(data[8:12])
    block_size=stoi(data[12:14])
    wave["bit"]=stoi(data[14:16])
    if wave["bit"] not in [8,16]:
        raise""
    if not data_speed==wave["rate"]*wave["channel"]*(wave["bit"]/8):
        raise""
    if not block_size==wave["channel"]*(wave["bit"]/8):
        raise""

def test():
    f=open("kaeru.wav","rb")
    s=f.read()
    f.close()
    wave=read(s)
    print wave.info
